package de.unikoblenz.fgbks.core.dmn.domain.vdmn;

import de.unikoblenz.fgbks.core.dmn.domain.ids.OutputId;
import java.util.List;
import org.camunda.bpm.model.dmn.instance.Output;

/**
 * This interface represents a output column in a {@link VDmnDecisionTable}. A column contains a
 * list of {@link VDmnOutputValue}s.
 */
public interface VDmnOutputColumn extends VDmnColumn {

  /**
   * Get original Output.
   *
   * @return the {@link Output}
   */
  Output getOutput();

  /**
   * Get the {@link OutputId} of the column.
   *
   * @return the {@link OutputId}.
   */
  default OutputId getOutputId() {
    return (OutputId) getColumnId();
  }

  /**
   * Get the list of {@link VDmnOutputValue} of the column.
   *
   * @return the list of {@link VDmnOutputValue}.
   */
  default List<VDmnOutputValue> getVDmnOutputValues() {
    return (List<VDmnOutputValue>) (List<?>) getValues();
  }
}
