package de.unikoblenz.fgbks.core.dmn.domain.vdmn.impl;

import de.unikoblenz.fgbks.base.utils.boundary.Boundary;
import de.unikoblenz.fgbks.core.dmn.domain.vdmn.VDmnInputValue;
import org.apache.commons.lang3.Validate;

/**
 * Implementation of {@link VDmnInputValue}. Create a input value with changeable boundaries.
 */
public class VDmnInputValueChangeableImpl extends VDmnInputValueImpl {

  public VDmnInputValueChangeableImpl(VDmnInputValueImpl inputValue) {
    super();
    Validate.notNull(inputValue);
    super.boundary = inputValue.boundary;
    super.description = inputValue.description;
    super.column = inputValue.column;
    super.rule = inputValue.rule;
    super.id = inputValue.id;
    super.text = inputValue.text;
  }

  public VDmnInputValueChangeableImpl withNewBoundary(Boundary boundary) {
    super.boundary = Validate.notNull(boundary);
    return this;
  }
}
